diff -r -C 2 -P ../AmiPhone_1.92/ciatimer.c ./ciatimer.c
*** ../AmiPhone_1.92/ciatimer.c	Sat Nov 16 23:46:44 1996
--- ./ciatimer.c	Sun Mar  1 20:47:16 1998
***************
*** 1,6 ****
--- 1,10 ----
+ 
+ /* :ts=4 */
+ 
  #include <time.h>
  #include <stdlib.h>
  #include <stdio.h>
  #include <string.h>
+ #include <math.h>
  
  #include <exec/io.h>
***************
*** 16,23 ****
  #include <clib/mathieeedoubbas_protos.h>
  
  #include <resources/cia.h>
  
  #include <libraries/dos.h>
- #include <libraries/delfina.h>
  #include <resources/misc.h>
  #include <utility/tagitem.h>
--- 20,29 ----
  #include <clib/mathieeedoubbas_protos.h>
  
+ #include <libraries/gadtools.h>
+ #include <clib/gadtools_protos.h>
+ 
  #include <resources/cia.h>
  
  #include <libraries/dos.h>
  #include <resources/misc.h>
  #include <utility/tagitem.h>
***************
*** 39,52 ****
  #include "messages.h"
  #include "codec.h"
- #include "delfph.h"
  
! #include "toccata/include/libraries/toccata.h"
! #include "toccata/include/clib/toccata_protos.h"
! #include "toccata/include/pragmas/toccata_pragmas.h"
  
  /* Some hardware addresses to sample from */
! #define AMIGA_HARDWARE_SAMPLE_ADDRESS 	((UBYTE *) (&pciaa->ciaprb))
! #define AURA_SAMPLE_ADDRESS_LEFT  	((UBYTE *) 0xA20000)
! #define AURA_SAMPLE_ADDRESS_RIGHT 	((UBYTE *) 0xA20002)
  
  	
--- 45,59 ----
  #include "messages.h"
  #include "codec.h"
  
! #include <libraries/toccata.h>
! #include <clib/toccata_protos.h>
! #include <pragmas/toccata_pragmas.h>
! 
! void kprintf(char *, ...);
  
  /* Some hardware addresses to sample from */
! #define AMIGA_HARDWARE_SAMPLE_ADDRESS	((UBYTE *) (&pciaa->ciaprb))
! #define AURA_SAMPLE_ADDRESS_LEFT	((UBYTE *) 0xA20000)
! #define AURA_SAMPLE_ADDRESS_RIGHT	((UBYTE *) 0xA20002)
  
  	
***************
*** 76,88 ****
  
  /* external data */
! extern void AHIhookEntry();	    /* hook stub */
  extern void Idle();			
  extern void InvertIdle();
  extern void PerfectIdle();
! extern void Record();          /* prototype for assembly interrupt routine */
  extern void PerfectRecord();   /* prototype for assembly interrupt routine */
  
  extern BOOL BTransmitting, BSoundOn, BButtonHeld, BSpaceTapped, BTCPBatchXmit, BUserDebug;
  extern UBYTE ubSamplerType, ubInputChannel, ubCurrComp, ubInputSource;
  extern UBYTE ubCustStart, ubCustStop, ubCustLeft, ubCustRight, ubCustMic, ubCustExt, ubCustDir;
  extern UBYTE * pubCustSampleAt;
--- 83,96 ----
  
  /* external data */
! extern void AHIhookEntry();		/* hook stub */
  extern void Idle();			
  extern void InvertIdle();
  extern void PerfectIdle();
! extern void Record();		   /* prototype for assembly interrupt routine */
  extern void PerfectRecord();   /* prototype for assembly interrupt routine */
  
  extern BOOL BTransmitting, BSoundOn, BButtonHeld, BSpaceTapped, BTCPBatchXmit, BUserDebug;
  extern UBYTE ubSamplerType, ubInputChannel, ubCurrComp, ubInputSource;
+ extern ULONG ulAHIMode;
  extern UBYTE ubCustStart, ubCustStop, ubCustLeft, ubCustRight, ubCustMic, ubCustExt, ubCustDir;
  extern UBYTE * pubCustSampleAt;
***************
*** 102,106 ****
  extern struct Library * AHIBase;
  extern struct Library * ToccataBase;
! extern struct Library * DelfinaBase;
  
  /* data */
--- 110,119 ----
  extern struct Library * AHIBase;
  extern struct Library * ToccataBase;
! 
! extern struct Window *PhoneWindow;
! 
! extern BOOL BUpdateMenus;
! extern struct Gadget *freqslider; 
! 
  
  /* data */
***************
*** 108,115 ****
  BYTE sighalf=0, sigfull=0;
  UBYTE * pubAllocedArray = NULL;
! UBYTE * pubRightBuffer  = NULL;
  int nLineGainValue=0, nMicGainValue=20;
  UBYTE * pubBulkSamplePacket = NULL;
! ULONG   ulBulkSamplePacketLen, ulBulkSamplePacketSum, ulAHIAudioMode = 0L;
  
  /* private data */
--- 121,129 ----
  BYTE sighalf=0, sigfull=0;
  UBYTE * pubAllocedArray = NULL;
! UBYTE * pubRightBuffer	= NULL;
  int nLineGainValue=0, nMicGainValue=20;
  UBYTE * pubBulkSamplePacket = NULL;
! ULONG	ulBulkSamplePacketLen, ulBulkSamplePacketSum;
! 
  
  /* private data */
***************
*** 121,124 ****
--- 135,139 ----
  static struct List * PreSendQueue = NULL;
  static int nCurrentPreSendQLen;
+ static UBYTE * pubAHIRecordBuffer = NULL;
  
  /* private function prototypes */
***************
*** 133,143 ****
  static void UpdatePreSendQueue(struct AmiPhoneSendBuffer * sBuf);
  static void FreePreSendNode(struct Node * current);
  
  /* Used by toccata & AHI samplers */
! static __geta4 BOOL ToccataSendData(UBYTE * ubData, ULONG ulDataSize);
! static __geta4 ULONG AHISendData(struct Hook *hook, struct AHIAudioCtrl * ctrl, struct AHIRecordMessage * msg);
  static BOOL StartToccataCapture(BOOL BStart, ULONG ulBPS);
  static BOOL StartAHICapture(BOOL BStart, ULONG ulBPS);
- static BOOL StartDelfinaCapture(BOOL BStart, ULONG ulBPS);
  
  /* Front-ends to setting the various data direction and control bits on the parallel port */
--- 148,159 ----
  static void UpdatePreSendQueue(struct AmiPhoneSendBuffer * sBuf);
  static void FreePreSendNode(struct Node * current);
+ static ULONG ProcessAHIBuffer(UBYTE * pubSrc, UBYTE * pubDst, ULONG ulDataLen, ULONG ulType);
+ static ULONG ProcessToccataBuffer(UBYTE * pubData, ULONG ulDataLen);
  
  /* Used by toccata & AHI samplers */
! static SAVEDS BOOL ToccataSendData(UBYTE * ubData, ULONG ulDataSize);
! static SAVEDS ULONG AHISendData(struct Hook *hook, struct AHIAudioCtrl * ctrl, struct AHIRecordMessage * msg);
  static BOOL StartToccataCapture(BOOL BStart, ULONG ulBPS);
  static BOOL StartAHICapture(BOOL BStart, ULONG ulBPS);
  
  /* Front-ends to setting the various data direction and control bits on the parallel port */
***************
*** 147,157 ****
  static char * RegToString(UBYTE ubReg);
  
! #define EVENT_NONE  0
  #define EVENT_START 1
! #define EVENT_STOP  2
! #define EVENT_LEFT  3
  #define EVENT_RIGHT 4
! #define EVENT_MIC   5
! #define EVENT_EXT   6
  
  char * szEventStrings[] = {
--- 163,173 ----
  static char * RegToString(UBYTE ubReg);
  
! #define EVENT_NONE	0
  #define EVENT_START 1
! #define EVENT_STOP	2
! #define EVENT_LEFT	3
  #define EVENT_RIGHT 4
! #define EVENT_MIC	5
! #define EVENT_EXT	6
  
  char * szEventStrings[] = {
***************
*** 172,182 ****
  	;
  	; STOP -
! 	; 	START bit 0 == 0 (STOP IMMEDIATELY)
! 	; 	PBON  bit 1 == same
! 	; 	OUT   bit 2 == same
! 	;	RUN   bit 3 == 0 (SET CONTINUOUS MODE)
  	;	LOAD  bit 4 == 0 (NO FORCE LOAD)
! 	;	IN    bit 5 == 0 (COUNTS 02 PULSES)
! 	;	SP    bit 6 == same
  	;	TODIN bit 7 == same (unused on ciacra)
  	;
--- 188,198 ----
  	;
  	; STOP -
! 	;	START bit 0 == 0 (STOP IMMEDIATELY)
! 	;	PBON  bit 1 == same
! 	;	OUT	  bit 2 == same
! 	;	RUN	  bit 3 == 0 (SET CONTINUOUS MODE)
  	;	LOAD  bit 4 == 0 (NO FORCE LOAD)
! 	;	IN	  bit 5 == 0 (COUNTS 02 PULSES)
! 	;	SP	  bit 6 == same
  	;	TODIN bit 7 == same (unused on ciacra)
  	;
***************
*** 191,201 ****
  	;
  	; STOP -
! 	; 	START bit 0 == 0 (STOP IMMEDIATELY)
! 	; 	PBON  bit 1 == same
! 	; 	OUT   bit 2 == same
! 	;	RUN   bit 3 == 0 (SET CONTINUOUS MODE)
  	;	LOAD  bit 4 == 0 (NO FORCE LOAD)
! 	;	IN0   bit 5 == 0 (COUNTS 02 PULSES)
! 	;	IN1   bit 6 == 0 (COUNDS 02 PULSES)
  	;	ALARM bit 7 == same (TOD alarm control bit)
  	;
--- 207,217 ----
  	;
  	; STOP -
! 	;	START bit 0 == 0 (STOP IMMEDIATELY)
! 	;	PBON  bit 1 == same
! 	;	OUT	  bit 2 == same
! 	;	RUN	  bit 3 == 0 (SET CONTINUOUS MODE)
  	;	LOAD  bit 4 == 0 (NO FORCE LOAD)
! 	;	IN0	  bit 5 == 0 (COUNTS 02 PULSES)
! 	;	IN1	  bit 6 == 0 (COUNDS 02 PULSES)
  	;	ALARM bit 7 == same (TOD alarm control bit)
  	;
***************
*** 268,272 ****
  			case SAMPLER_SOMAGIC:
  				BWasInput = ((pciab->ciaddra & CIAF_PRTRBUSY) == 0);
! 		     		pciab->ciaddra &= ~(CIAF_PRTRBUSY); /* set this line to input so we can read it */
  				PrevSource = (pciab->ciapra & CIAF_PRTRBUSY) ? INPUT_SOURCE_EXT : INPUT_SOURCE_MIC;
  				UNLESS(BWasInput) pciab->ciaddra |= CIAF_PRTRBUSY;	/* put it back to original state */
--- 284,288 ----
  			case SAMPLER_SOMAGIC:
  				BWasInput = ((pciab->ciaddra & CIAF_PRTRBUSY) == 0);
! 					pciab->ciaddra &= ~(CIAF_PRTRBUSY); /* set this line to input so we can read it */
  				PrevSource = (pciab->ciapra & CIAF_PRTRBUSY) ? INPUT_SOURCE_EXT : INPUT_SOURCE_MIC;
  				UNLESS(BWasInput) pciab->ciaddra |= CIAF_PRTRBUSY;	/* put it back to original state */
***************
*** 293,297 ****
  	
  	if ((nNewSamplerType < 0)||(nNewSamplerType >= SAMPLER_MAX)) return;
- 	if ((nNewSamplerType == SAMPLER_DELFINA)&&(!DelfinaBase)) return;
  	if ((nNewSamplerType == SAMPLER_TOCCATA)&&(!ToccataBase)) return;
  	if ((nNewSamplerType == SAMPLER_AHI)&&(!AHIBase)) return;
--- 309,312 ----
***************
*** 303,309 ****
--- 318,454 ----
  	ChangeInputSource(ubInputSource,TRUE);
  
+ 	BUpdateMenus = TRUE;
+ 
+ 	if(ubSamplerType == SAMPLER_AHI)
+ 	{
+ 		LONG freqs = 0, index = 0, inputs = 0;
+ 		int i;
+ 		
+ 		AHI_GetAudioAttrs(ulAHIMode, NULL,
+ 			AHIDB_Frequencies,	&freqs,
+ 			AHIDB_IndexArg,		ulBytesPerSecond,
+ 			AHIDB_Index,		&index,
+ 			AHIDB_FrequencyArg,	0,
+ 			AHIDB_Inputs		&inputs,
+ 			TAG_DONE);
+ 
+ 
+ 		/* Remove frequencies over nMaxSampleRate */
+ 
+ 		for( i = freqs; i > 0; i--)
+ 		{
+ 			LONG freq = 0;
+ 
+ 			AHI_GetAudioAttrs(ulAHIMode, NULL,
+ 				AHIDB_FrequencyArg,	i,
+ 				AHIDB_Frequency,	&freq,
+ 				TAG_DONE);
+ 			
+ 			if(freq > nMaxSampleRate)
+ 			{
+ 				freqs--;
+ 			}
+ 		}
+ 
+ 		/* Make sure the selected frequency is in range */
+ 
+ 		index = max(0, min(index, freqs - 1));
+ 
+ 		/* Set ulBytesPerSecond */
+ 
+ 		AHI_GetAudioAttrs(ulAHIMode, NULL,
+ 			AHIDB_FrequencyArg,	index,
+ 			AHIDB_Frequency,	&ulBytesPerSecond,
+ 			TAG_DONE);
+ 
+ 		/* Set frequency slider */
+ 
+ 		GT_SetGadgetAttrs(freqslider,PhoneWindow,NULL,
+ 			GTSL_Min,		0,
+ 			GTSL_Max,		freqs,
+ 			GTSL_Level,		index,
+ 			TAG_END);
+ 	}
+ 	else
+ 	{
+ 		GT_SetGadgetAttrs(freqslider,PhoneWindow,NULL,
+ 			GTSL_Min,		(WORD)MIN_SAMPLE_RATE,
+ 			GTSL_Max,		(WORD)nMaxSampleRate,
+ 			GTSL_Level,		(WORD)ulBytesPerSecond,
+ 			TAG_END);
+ 	}
+ 
  	if (BWasTransmitting) ToggleMicButton(CODE_ON);
  }
  
+ static struct TagItem ReqFilterTags[] =
+ {
+ //	  AHIDB_Realtime,	TRUE,
+ 	AHIDB_Record,	TRUE,
+ 	TAG_DONE,		NULL
+ };
+ 
+ 
+ static ULONG ASMCALL SAVEDS
+ ReqFunc( REG(a0, struct Hook *hook),
+ 		 REG(a2, struct AHIAudioModeRequester *req),
+ 		 REG(a1, ULONG id) )
+ {
+ 	// Dirty! Filter all Paula modes away.
+ 	if((id & 0x001f0000) == 0x00020000) return 0;
+ 	return 1;
+ }
+ 
+ static struct Hook
+ ReqHook = {
+ 	0, 0,
+ 	ReqFunc, NULL, NULL
+ };
+ 
+ 
+ void ChangeAHIMode(void)
+ {
+ 	struct AHIAudioModeRequester *req;
+ 	BOOL rc = FALSE;
+ 
+ 	if(AHIBase == NULL) return;
+ 
+ 	req = AHI_AllocAudioRequest(
+ 		AHIR_Window,			PhoneWindow,
+ 		AHIR_SleepWindow,		TRUE,
+ 		AHIR_DoDefaultMode,		TRUE,
+ 		AHIR_InitialAudioID,	ulAHIMode,
+ 		AHIR_FilterTags,		ReqFilterTags,
+ 		AHIR_FilterFunc,		&ReqHook,
+ 		TAG_DONE);
+ 
+ 	if(req == NULL)
+ 	{
+ 		SetWindowTitle("Out of memory!");
+ 		return;
+ 	}
+ 
+ 	rc = AHI_AudioRequest(req, TAG_DONE);
+ 
+ 	if(!rc)
+ 	{
+ 		if(IoErr() == ERROR_NO_FREE_STORE)
+ 			SetWindowTitle("Out of memory!");
+ 		else if(IoErr() == ERROR_NO_MORE_ENTRIES)
+ 			SetWindowTitle("No available modes!");
+ 	}
+ 	else
+ 	{
+ 		ulAHIMode = req->ahiam_AudioID;
+ 		ubInputSource = 0;
+ 		BUpdateMenus = TRUE;
+ 	}
+ 
+ 	AHI_FreeAudioRequest(req);
+ 
+ 	/* Update */
+ 	ChangeSamplerType(ubSamplerType);
+ 
+ }
  
  	
***************
*** 311,330 ****
  {
  	struct TagItem taglist[3];
! 	
! 	if (BMakeCurrentMode) ubInputSource = nNewSource;
  	
  	switch(ubSamplerType)
  	{
  		case SAMPLER_TOCCATA:
! 			taglist[0].ti_Tag  = PAT_Input;        
  			switch (ubInputSource)
  			{
! 				case INPUT_SOURCE_MIC: taglist[0].ti_Data = TINPUT_Mic;  break;
  				case INPUT_SOURCE_EXT: taglist[0].ti_Data = TINPUT_Line; break;
  			}
! 			taglist[1].ti_Tag  = TAG_DONE;	taglist[1].ti_Data = NULL;
  			T_SetPart(taglist);
  			break;
! 		
  		case SAMPLER_SOMAGIC:
  			switch(nNewSource)
--- 456,493 ----
  {
  	struct TagItem taglist[3];
! 
! 	if(nNewSource < 0) nNewSource = 0;
  	
  	switch(ubSamplerType)
  	{
  		case SAMPLER_TOCCATA:
! 			taglist[0].ti_Tag  = PAT_Input;		   
  			switch (ubInputSource)
  			{
! 				case INPUT_SOURCE_MIC: taglist[0].ti_Data = TINPUT_Mic;	 break;
  				case INPUT_SOURCE_EXT: taglist[0].ti_Data = TINPUT_Line; break;
  			}
! 			taglist[1].ti_Tag  = TAG_DONE;	taglist[1].ti_Data = 0;
  			T_SetPart(taglist);
  			break;
! 
! 		case SAMPLER_AHI:
! 		{
! 			ULONG inputs = 0;
! 
! 			AHI_GetAudioAttrs( ulAHIMode, NULL,
! 				AHIDB_Inputs, &inputs,
! 				TAG_DONE);
! 
! 			nNewSource = max(0, min(nNewSource, inputs - 1));
! 
! 			if(AHIAudioControl)
! 			{
! 				AHI_ControlAudio(AHIAudioControl, 
! 					AHIC_Input, nNewSource,
! 					TAG_DONE);
! 			}
! 		}
! 
  		case SAMPLER_SOMAGIC:
  			switch(nNewSource)
***************
*** 335,345 ****
  			break;
  	
- 		case SAMPLER_DELFINA:
- 			taglist[0].ti_Tag = DA_MicIn;	taglist[0].ti_Data = (nNewSource == INPUT_SOURCE_MIC);
- 			taglist[1].ti_Tag = DA_LineIn;	taglist[1].ti_Data = (nNewSource == INPUT_SOURCE_EXT);
- 			taglist[2].ti_Tag = TAG_DONE;	taglist[2].ti_Data = NULL;
- 			Delf_SetAttrsA(taglist);
- 			break;
- 				
  		case SAMPLER_CUSTOM:
  			switch(ubInputSource)
--- 498,501 ----
***************
*** 349,352 ****
--- 505,510 ----
  			}
  	}
+ 
+ 	if (BMakeCurrentMode) ubInputSource = nNewSource;
  }
  
***************
*** 361,371 ****
  				 break;
  						
! 			case SAMPLER_GVPDSS8: 	/* this verified to work by JAF */
  				 SetParallelBits(EVENT_NONE,SAMPBIT_SELSET);
! 			  	 break;		
  				 
  			case SAMPLER_SOMAGIC:
  				 SetParallelBits(EVENT_NONE,SAMPBIT_POUTCLR | SAMPBIT_SELSET);
! 			 	 break;
  
  			case SAMPLER_AURA:
--- 519,529 ----
  				 break;
  						
! 			case SAMPLER_GVPDSS8:	/* this verified to work by JAF */
  				 SetParallelBits(EVENT_NONE,SAMPBIT_SELSET);
! 				 break;		
  				 
  			case SAMPLER_SOMAGIC:
  				 SetParallelBits(EVENT_NONE,SAMPBIT_POUTCLR | SAMPBIT_SELSET);
! 				 break;
  
  			case SAMPLER_AURA:
***************
*** 378,390 ****
  				 break;		
  			
- 			case SAMPLER_DELFINA:
- 				 if (StartSampling(CHECK_STATUS,0) == TRUE) 
- 				 {
- 					ubInputChannel = INPUT_JACK_LEFT;	/* must be set BEFORE the StartSampling pair! */
- 					BTransmitting = StartSampling(FALSE,0);
- 					BTransmitting = StartSampling(TRUE,ulBytesPerSecond);
- 				 }
- 				 break;
- 				 					 
  			default: case SAMPLER_PERFECT: case SAMPLER_AMAS: 
  				 /* as described by Marcel Offermans & AGMSRecordSound author */
--- 536,539 ----
***************
*** 400,412 ****
  				 break;
  			
- 			case SAMPLER_DELFINA:
- 				 if (StartSampling(CHECK_STATUS,0) == TRUE) 
- 				 {
- 					ubInputChannel = INPUT_JACK_RIGHT;	/* must be set BEFORE the StartSampling pair! */
- 					BTransmitting = StartSampling(FALSE,0);
- 					BTransmitting = StartSampling(TRUE,ulBytesPerSecond);
- 				 }
- 				 break;	 					 
- 
  			case SAMPLER_GVPDSS8: 
  				 SetParallelBits(EVENT_NONE, SAMPBIT_SELCLR);
--- 549,552 ----
***************
*** 425,429 ****
  				 if (pubCustSampleAt) IntData.pubSampleAt = pubCustSampleAt;
  				 break;
! 				 				 
  			default: case SAMPLER_PERFECT: case SAMPLER_AMAS: 
  				 SetParallelBits(EVENT_NONE, SAMPBIT_POUTCLR | SAMPBIT_SELSET);
--- 565,569 ----
  				 if (pubCustSampleAt) IntData.pubSampleAt = pubCustSampleAt;
  				 break;
! 								 
  			default: case SAMPLER_PERFECT: case SAMPLER_AMAS: 
  				 SetParallelBits(EVENT_NONE, SAMPBIT_POUTCLR | SAMPBIT_SELSET);
***************
*** 455,460 ****
  	if (ubSamplerType == SAMPLER_AHI) return(BTimerStarted = StartAHICapture(BStart, ulBPS));
  	
- 	if (ubSamplerType == SAMPLER_DELFINA) return(BTimerStarted = StartDelfinaCapture(BStart, ulBPS));
- 	
  	/* set up data which will be passed to interrupt */
  	if (BStart == TRUE)
--- 595,598 ----
***************
*** 465,469 ****
  		{
  			ResetDigitizer(FALSE);	/* record state */
! 			BFirstTime = FALSE;	
  		}
  		
--- 603,607 ----
  		{
  			ResetDigitizer(FALSE);	/* record state */
! 			BFirstTime = FALSE; 
  		}
  		
***************
*** 476,481 ****
  		AmiPhoneTimer.timerint.is_Node.ln_Pri  = 0;
  		AmiPhoneTimer.timerint.is_Node.ln_Name = "AmiPhone Sample Timer";
! 		AmiPhoneTimer.timerint.is_Data	       = (APTR) &IntData;
! 		AmiPhoneTimer.timerint.is_Code	       = (ubSamplerType == SAMPLER_PERFECT) ? PerfectIdle : ((UsesInvertedSamples()) ? InvertIdle : Idle);
  		
  		/* Call function to find a free CIA interval timer
--- 614,619 ----
  		AmiPhoneTimer.timerint.is_Node.ln_Pri  = 0;
  		AmiPhoneTimer.timerint.is_Node.ln_Name = "AmiPhone Sample Timer";
! 		AmiPhoneTimer.timerint.is_Data		   = (APTR) &IntData;
! 		AmiPhoneTimer.timerint.is_Code		   = (ubSamplerType == SAMPLER_PERFECT) ? PerfectIdle : ((UsesInvertedSamples()) ? InvertIdle : Idle);
  		
  		/* Call function to find a free CIA interval timer
***************
*** 517,521 ****
  
  		/* Send what we have of the current packet, if we were sending */
! 		pubPartialSend     = (IntData.pubIndex >= IntData.pubHalfIndex) ? IntData.pubHalfIndex : IntData.pubArray;
  		nPartialSendLength = (int) (IntData.pubIndex-pubPartialSend);
  		if (nPartialSendLength == 0) nPartialSendLength = 1;
--- 655,659 ----
  
  		/* Send what we have of the current packet, if we were sending */
! 		pubPartialSend	   = (IntData.pubIndex >= IntData.pubHalfIndex) ? IntData.pubHalfIndex : IntData.pubArray;
  		nPartialSendLength = (int) (IntData.pubIndex-pubPartialSend);
  		if (nPartialSendLength == 0) nPartialSendLength = 1;
***************
*** 523,527 ****
  		/* pro-rate the partial sample's volume to represent the full range */
  		IntData.ulSaveByteSum = ((ULONG) (IntData.ulByteSum * ((ULONG)(IntData.pubHalfIndex-IntData.pubArray)))) / ((ULONG) nPartialSendLength);
! 		TransmitData(pubPartialSend, nPartialSendLength, ubCurrComp);			    
  		
  		/* Deallocate any RAM that was previously allocated */
--- 661,665 ----
  		/* pro-rate the partial sample's volume to represent the full range */
  		IntData.ulSaveByteSum = ((ULONG) (IntData.ulByteSum * ((ULONG)(IntData.pubHalfIndex-IntData.pubArray)))) / ((ULONG) nPartialSendLength);
! 		TransmitData(pubPartialSend, nPartialSendLength, ubCurrComp);				
  		
  		/* Deallocate any RAM that was previously allocated */
***************
*** 531,535 ****
  	}
  	return(BTimerStarted);
! };
  
  
--- 669,673 ----
  	}
  	return(BTimerStarted);
! }
  
  
***************
*** 539,622 ****
  static BOOL StartAHICapture(BOOL BStart, ULONG ulBPS)
  {
- 	struct TagItem taglist[15];
  	static struct Hook RecordFuncHook;
! 	ULONG ulAHIVolume,ulAHIRecord,ulAHIRealtime,ulAHIBits,ulAHIFrequencies,
! 	      ulAHIIndex,ulAHIMaxRecordSamples,ulBestAudioMode, ulError;
! 	char szDriverName[200] = "szDriverName",
! 	     szModeName[200]   = "szModeName",
! 	     szAuthorName[200] = "szAuthorName",
! 	     szVersionName[200]= "szVersionName";
  	
  	if (BStart)
  	{
! 		printf("StartAHICapture():  Setting up capture....\n");
! 		
! 		taglist[0].ti_Tag = AHIDB_Record; taglist[0].ti_Data = TRUE;
! 		taglist[1].ti_Tag = AHIDB_Bits;   taglist[1].ti_Data = 8;
! 		taglist[2].ti_Tag = TAG_DONE;	  taglist[2].ti_Data = NULL;
! 		ulBestAudioMode = AHI_BestAudioIDA(taglist);
! 		
! 		printf("ulBestAudioMode is 0x%X\n",ulBestAudioMode);
! 		if (ulBestAudioMode == AHI_INVALID_ID) printf("Warning, INVALID ID!\n");
! 		
! 		taglist[0].ti_Tag  = AHIDB_Volume; 	taglist[0].ti_Data  = &ulAHIVolume;
! 		taglist[1].ti_Tag  = AHIDB_Record; 	taglist[1].ti_Data  = &ulAHIRecord;
! 		taglist[2].ti_Tag  = AHIDB_Realtime; 	taglist[2].ti_Data  = &ulAHIRealtime;
! 		taglist[3].ti_Tag  = AHIDB_Bits; 	taglist[3].ti_Data  = &ulAHIBits;
! 		taglist[4].ti_Tag  = AHIDB_Frequencies; taglist[4].ti_Data  = &ulAHIFrequencies;
! 		taglist[5].ti_Tag  = AHIDB_Index; 	taglist[5].ti_Data  = &ulAHIIndex;
! 		taglist[6].ti_Tag  = AHIDB_IndexArg; 	taglist[6].ti_Data  = ulBPS;
! 		taglist[7].ti_Tag  = AHIDB_MaxRecordSamples; taglist[7].ti_Data = &ulAHIMaxRecordSamples;
! 		taglist[8].ti_Tag  = AHIDB_BufferLen;   taglist[8].ti_Data  = sizeof(szDriverName);
! 		taglist[9].ti_Tag  = AHIDB_Driver; 	taglist[9].ti_Data  = szDriverName;
! 		taglist[10].ti_Tag = AHIDB_Name; 	taglist[10].ti_Data = szModeName;
! 		taglist[11].ti_Tag = AHIDB_Author; 	taglist[11].ti_Data = szAuthorName;
! 		taglist[12].ti_Tag = AHIDB_Version;	taglist[12].ti_Data = szVersionName;
! 		taglist[13].ti_Tag = TAG_DONE; 		taglist[13].ti_Data = NULL;
! 		UNLESS(AHI_GetAudioAttrsA(ulBestAudioMode, NULL, taglist))
  		{
! 			printf("AHI_GetAudioAttrsA failed!\n");
  			return(FALSE);
  		}
  
! 		printf("---------AHI_GetAudioAttrs reports:\n");
! 		printf("VolumeAdjustable = %lu\n",ulAHIVolume);
! 		printf("CanRecord        = %lu\n",ulAHIRecord);
! 		printf("Realtime         = %lu\n",ulAHIRealtime);
! 		printf("BitsPerSample    = %lu\n",ulAHIBits);
! 		printf("NumFrequencies   = %lu\n",ulAHIFrequencies);
! 		printf("IndexOf(f=%lu)   = %lu\n",ulBPS,ulAHIIndex);
! 		printf("MaxRecordSamples = %lu\n",ulAHIMaxRecordSamples);
! 		printf("szDriverName  = [%s]\n",szDriverName);
! 		printf("szModeName    = [%s]\n",szModeName);
! 		printf("szAuthorName  = [%s]\n",szAuthorName);
! 		printf("szVersionName = [%s]\n",szVersionName);
! 		printf("---------End AHI_GetAudioAttrs\n");
  
! 		/* Setup our Hook! */
! 		RecordFuncHook.h_Entry    = (ULONG (*) ()) AHIhookEntry;
! 		RecordFuncHook.h_SubEntry = AHISendData;
! 		RecordFuncHook.h_Data	  = NULL;	/* Should there be something here? */
! 		
! 		/* Now start the capture */
! 		taglist[0].ti_Tag = AHIA_AudioID; 	taglist[0].ti_Data = ulBestAudioMode;
! 		taglist[1].ti_Tag = AHIA_Channels;	taglist[1].ti_Data = 0;	/* Is zero channels okay since we won't be playing any sounds?? */
! 		taglist[2].ti_Tag = AHIA_Sounds;  	taglist[2].ti_Data = 0;	/* What is this arg, anyway??? */
! 		taglist[3].ti_Tag = AHIA_RecordFunc;	taglist[3].ti_Data = &RecordFuncHook;
! 		taglist[4].ti_Tag = TAG_DONE;	  	taglist[4].ti_Data = NULL;
! 		UNLESS(AHIAudioControl = AHI_AllocAudioA(taglist))
  		{
! 			SetWindowTitle("AHI_AllocAudioA failed!");
  			return(FALSE);
  		}
! 		ulAHIAudioMode = ulBestAudioMode;
! 		
! 		taglist[0].ti_Tag = AHIC_Play; 		taglist[0].ti_Data = FALSE;
! 		taglist[1].ti_Tag = AHIC_Record;	taglist[1].ti_Data = TRUE;
! 		taglist[2].ti_Tag = AHIA_RecordFunc;	taglist[2].ti_Data = &RecordFuncHook;
! 		taglist[3].ti_Tag = TAG_DONE;	  	taglist[3].ti_Data = NULL;
! 		if (ulError = AHI_ControlAudioA(AHIAudioControl, taglist))
  		{
! 			printf("AHI_ControlAudioA failed, error %lu\n",ulError);
  			AHI_FreeAudio(AHIAudioControl); AHIAudioControl = NULL;
  			return(FALSE);
--- 677,728 ----
  static BOOL StartAHICapture(BOOL BStart, ULONG ulBPS)
  {
  	static struct Hook RecordFuncHook;
! 	ULONG ulError = AHIE_OK;
! 	ULONG inputs = 0, samples = 0;
  	
+ 	if(AHIBase == NULL) return FALSE;
+ 
  	if (BStart)
  	{
! 		/* Setup our Hook! */
! 		RecordFuncHook.h_Entry	  = (ULONG (*) ()) AHIhookEntry;
! 		RecordFuncHook.h_SubEntry = AHISendData;
! 		RecordFuncHook.h_Data	  = NULL;	/* Should there be something here? */
! 
! 		/* Now start the capture */
! 		UNLESS(AHIAudioControl = AHI_AllocAudio(
! 			AHIA_AudioID,		ulAHIMode,
! 			AHIA_MixFreq,		ulBytesPerSecond,
! 			AHIA_Channels,		1,
! 			AHIA_Sounds,		1,
! 			AHIA_RecordFunc,	&RecordFuncHook,
! 			TAG_DONE))
  		{
! 			SetWindowTitle("AHI_AllocAudio failed!");
  			return(FALSE);
  		}
  
! 		AHI_GetAudioAttrs( AHI_INVALID_ID, AHIAudioControl,
! 			AHIDB_Inputs,			&inputs,
! 			AHIDB_MaxRecordSamples, &samples,
! 			TAG_DONE);
  
! 		pubAHIRecordBuffer = AllocVec(samples, MEMF_PUBLIC);
! 
! 		if(pubAHIRecordBuffer == NULL)
  		{
! 			printf("Out of memory!\n");
! 			AHI_FreeAudio(AHIAudioControl); AHIAudioControl = NULL;
  			return(FALSE);
  		}
! 
! 		ubInputSource = min(ubInputSource, inputs - 1);
! 
! 		if (ulError = AHI_ControlAudio(AHIAudioControl, 
! 			AHIC_Record,	TRUE,
! 			AHIC_Input,		ubInputSource,
! 			TAG_DONE))
  		{
! 			printf("AHI_ControlAudio failed, error %lu\n",ulError);
  			AHI_FreeAudio(AHIAudioControl); AHIAudioControl = NULL;
  			return(FALSE);
***************
*** 626,639 ****
  	else
  	{
- 		printf("StartAHICapture():  Ending capture....\n");
  		if (AHIAudioControl)
  		{
! 			taglist[0].ti_Tag = AHIC_Play; 		taglist[0].ti_Data = FALSE;
! 			taglist[1].ti_Tag = AHIC_Record;	taglist[1].ti_Data = FALSE;
! 			taglist[2].ti_Tag = TAG_DONE;	  	taglist[2].ti_Data = NULL;
! 			if (ulError = AHI_ControlAudioA(AHIAudioControl, taglist))
! 				printf("AHI_ControlAudioA failed on stop, error %lu\n",ulError);
  			AHI_FreeAudio(AHIAudioControl); 
  			AHIAudioControl = NULL;
  		}
  		else printf("Um, AHIAudioControl was like, NULL or something\n");
--- 732,746 ----
  	else
  	{
  		if (AHIAudioControl)
  		{
! 			if (ulError = AHI_ControlAudio(AHIAudioControl,
! 				AHIC_Record,	FALSE,
! 				TAG_DONE))
! 				printf("AHI_ControlAudio failed on stop, error %lu\n",ulError);
  			AHI_FreeAudio(AHIAudioControl); 
  			AHIAudioControl = NULL;
+ 
+ 			FreeVec(pubAHIRecordBuffer);
+ 			pubAHIRecordBuffer = NULL;
  		}
  		else printf("Um, AHIAudioControl was like, NULL or something\n");
***************
*** 645,688 ****
  
  
- /* Returns current state of the delfina sampler after operation attempted! */
- static BOOL StartDelfinaCapture(BOOL BStart, ULONG ulBPS)
- {
- 	int compmode;
- 	
- 	if (BStart)
- 	{
- 		UNLESS(DelfinaBase) return(FALSE);
- 
- 		ulSampleArraySize = ((CalcSampleArraySize(ulBPS, ubCurrComp, fPacketDelay) >> 4)+1)<<3;
- 
- 		switch(ubCurrComp)
- 		{
- 			case COMPRESS_ADPCM2:	compmode = 1; break;
- 			case COMPRESS_ADPCM3:	compmode = 2; break;
- 			default:				compmode = 0; break;
- 		}
- 		/* Now allocate a buffer for us.  The >>3 is due to warts in AllocSamplingBuffer (read its header for more info) */
- 		UNLESS(AllocSamplingBuffer(ulSampleArraySize>>3))
- 		{
- 			printf("StartDelfinaCapture():  Couldn't allocate sampling buffer!\n");
- 			return(FALSE);
- 		}
- 		UNLESS(StartDelfina(ulBPS, ulSampleArraySize, compmode, (ubInputChannel == INPUT_JACK_RIGHT)))
- 		{
- 			printf("StartDelfinaCapture(): StartDelfina() failed!\n");
- 			AllocSamplingBuffer(0);
- 			return(FALSE);
- 		}
- 		return(TRUE);
- 	}
- 	else
- 	{
- 		StopDelfina();
- 		AllocSamplingBuffer(0);	/* Free the mem we were using */
- 		return(FALSE);
- 	}	
- }
- 
- 
  /* BSTart controls whether to start or stop capture.  ulBPS is, of course,
     the sampling rate (for the Toccata, this should be set to one of the
--- 752,755 ----
***************
*** 724,733 ****
  		/* Prepare taglist to send to T_Capture */
  		taglist[0].ti_Tag  = TT_BufferSize; taglist[0].ti_Data = ulTocArraySize;
! 		taglist[1].ti_Tag  = TT_Save;	    taglist[1].ti_Data = ToccataSendData;
! 		taglist[2].ti_Tag  = TT_Mode;	    taglist[2].ti_Data = TMODE_LINEAR_8;
! 		taglist[3].ti_Tag  = TT_Frequency;  taglist[3].ti_Data = ulBPS;
! 		taglist[4].ti_Tag  = TT_ErrorTask;  taglist[4].ti_Data = MainTask;
! 		taglist[5].ti_Tag  = TT_ErrorMask;  taglist[5].ti_Data = SIGBREAKF_CTRL_D;
! 		taglist[6].ti_Tag  = TAG_DONE;	    taglist[6].ti_Data = NULL;
  
  		/* and off it goes! */
--- 791,800 ----
  		/* Prepare taglist to send to T_Capture */
  		taglist[0].ti_Tag  = TT_BufferSize; taglist[0].ti_Data = ulTocArraySize;
! 		taglist[1].ti_Tag  = TT_Save;		taglist[1].ti_Data = ToccataSendData;
! 		taglist[2].ti_Tag  = TT_Mode;		taglist[2].ti_Data = TMODE_LINEAR_8;
! 		taglist[3].ti_Tag  = TT_Frequency;	taglist[3].ti_Data = ulBPS;
! 		taglist[4].ti_Tag  = TT_ErrorTask;	taglist[4].ti_Data = MainTask;
! 		taglist[5].ti_Tag  = TT_ErrorMask;	taglist[5].ti_Data = SIGBREAKF_CTRL_D;
! 		taglist[6].ti_Tag  = TAG_DONE;		taglist[6].ti_Data = 0;
  
  		/* and off it goes! */
***************
*** 753,762 ****
  
  /* Called by AHI whenever data is to be xmitted */	
! static __geta4 ULONG AHISendData(struct Hook *hook, struct AHIAudioCtrl * ctrl, struct AHIRecordMessage * msg)
  {
! 	pubBulkSamplePacket   = msg->ahirm_Buffer; 
! 	ulSampleArraySize     = msg->ahirm_Length;
  
! 	ulBulkSamplePacketSum = ProcessAHIBuffer(pubBulkSamplePacket, &ulSampleArraySize, msg->ahirm_Type);
  	Signal(MainTask, SIGBREAKF_CTRL_F);
  	return(1);
--- 820,830 ----
  
  /* Called by AHI whenever data is to be xmitted */	
! static SAVEDS ULONG AHISendData(struct Hook *hook, struct AHIAudioCtrl * ctrl, struct AHIRecordMessage * msg)
  {
! 	pubBulkSamplePacket	  = pubAHIRecordBuffer;
! 	ulSampleArraySize	  = msg->ahirm_Length;
  
! 	ulBulkSamplePacketSum = ProcessAHIBuffer(msg->ahirm_Buffer, 
! 		 pubBulkSamplePacket, ulSampleArraySize, msg->ahirm_Type);
  	Signal(MainTask, SIGBREAKF_CTRL_F);
  	return(1);
***************
*** 765,772 ****
  
  /* called by the Toccata library whenever we need to send the data */
! static __geta4 BOOL ToccataSendData(UBYTE * pubData, ULONG ulDataSize)
  {	
! 	pubBulkSamplePacket   = pubData;
! 	ulSampleArraySize     = ulDataSize;
  
  	ulBulkSamplePacketSum = ProcessToccataBuffer(pubData, ulDataSize);
--- 833,840 ----
  
  /* called by the Toccata library whenever we need to send the data */
! static SAVEDS BOOL ToccataSendData(UBYTE * pubData, ULONG ulDataSize)
  {	
! 	pubBulkSamplePacket	  = pubData;
! 	ulSampleArraySize	  = ulDataSize;
  
  	ulBulkSamplePacketSum = ProcessToccataBuffer(pubData, ulDataSize);
***************
*** 789,804 ****
  	switch(ubSamplerType)
  	{
- 	   case SAMPLER_DELFINA:
- 		nLineGainValue = ChopValue(nLineGainValue+nSteps,0,15);
- 		taglist[0].ti_Tag = DA_InputGain;	taglist[0].ti_Data = (nLineGainValue * 0x10000)/15;
- 		taglist[1].ti_Tag = TAG_DONE;		taglist[1].ti_Data = NULL;
- 		Delf_SetAttrsA(taglist);
- 		break;
- 		
  	   case SAMPLER_TOCCATA:
! 		nLineGainValue = ChopValue(nLineGainValue+nSteps,0,15);	
  		taglist[0].ti_Tag  = PAT_InputVolumeRight; taglist[0].ti_Data = nLineGainValue;
  		taglist[1].ti_Tag  = PAT_InputVolumeLeft;  taglist[1].ti_Data = nLineGainValue;
! 		taglist[2].ti_Tag  = TAG_DONE; 		   taglist[2].ti_Data = NULL;
  		T_SetPart(taglist);
  		break;
--- 857,865 ----
  	switch(ubSamplerType)
  	{
  	   case SAMPLER_TOCCATA:
! 		nLineGainValue = ChopValue(nLineGainValue+nSteps,0,15); 
  		taglist[0].ti_Tag  = PAT_InputVolumeRight; taglist[0].ti_Data = nLineGainValue;
  		taglist[1].ti_Tag  = PAT_InputVolumeLeft;  taglist[1].ti_Data = nLineGainValue;
! 		taglist[2].ti_Tag  = TAG_DONE;		   taglist[2].ti_Data = 0;
  		T_SetPart(taglist);
  		break;
***************
*** 806,810 ****
  	   case SAMPLER_GVPDSS8:
  		nLineGainValue = ChopValue(nLineGainValue+nSteps,0,7);
! 	        pciaa->ciaddrb  = 0xFF;	/* set data direction bits to output */
  		SetDirectionBits(SAMPBIT_BUSYSET);	/* busy bit as output */
  		SetParallelBits(EVENT_NONE, SAMPBIT_BUSYCLR);
--- 867,871 ----
  	   case SAMPLER_GVPDSS8:
  		nLineGainValue = ChopValue(nLineGainValue+nSteps,0,7);
! 			pciaa->ciaddrb	= 0xFF; /* set data direction bits to output */
  		SetDirectionBits(SAMPBIT_BUSYSET);	/* busy bit as output */
  		SetParallelBits(EVENT_NONE, SAMPBIT_BUSYCLR);
***************
*** 812,816 ****
  		SetParallelBits(EVENT_NONE, SAMPBIT_BUSYSET);
  		SetDirectionBits(SAMPBIT_BUSYCLR);
! 	        pciaa->ciaddrb  = 0x00;	/* data back to input */
  		break;
  		
--- 873,877 ----
  		SetParallelBits(EVENT_NONE, SAMPBIT_BUSYSET);
  		SetDirectionBits(SAMPBIT_BUSYCLR);
! 			pciaa->ciaddrb	= 0x00; /* data back to input */
  		break;
  		
